<template>
  <v-container>
    <v-layout row>
      <v-flex xs12 sm6 offset-sm3>
        <v-card>
          <v-list two-line>
            <template v-for="item in petugas">
              <v-list-tile avatar v-bind:key="item.id" @click="showUpdateForm(item)">
                <v-list-tile-avatar>
                  <v-avatar class="teal">
                    <span class="white--text headline text-xs-center">{{ item.id }}</span>
                  </v-avatar>
                </v-list-tile-avatar>
                <v-list-tile-content>
                  <v-list-tile-title v-html="item.username"></v-list-tile-title>
                  <v-list-tile-sub-title v-html="item.email"></v-list-tile-sub-title>
                </v-list-tile-content>
              </v-list-tile>
            </template>
          </v-list>
        </v-card>
      </v-flex>

      <v-dialog
        presistent
        max-width="600px"
        v-model="formUpdate"
      >
        <v-card>
          <v-card-title>Form Ubah Petugas</v-card-title>
          <v-divider></v-divider>
          <v-card-text>
            <form-petugas
              v-on:submit="submitUpdateForm" v-on:cancel="cancelUpdateForm" v-on:destroy="submitDestroyForm"
              :prop-form="dataUpdateForm" :update="true"></form-petugas>
          </v-card-text>
        </v-card>
      </v-dialog>
    </v-layout><!--/LayoutList-->

    <v-dialog
      presistent
      max-width="600px"
      v-model="formInsert"
    >
      <v-btn
        fixed dark fab bottom right color="green"
        @click="''"
        slot="activator"
      >
        <v-icon>add</v-icon>
      </v-btn>
      <v-card>
        <v-card-title>Form Tambah Petugas</v-card-title>
        <v-divider></v-divider>
        <v-card-text>
          <form-petugas v-on:submit="submitInsertForm" v-on:cancel="cancelInsertForm"></form-petugas>
        </v-card-text>
      </v-card>
    </v-dialog>
  </v-container>
</template>

<script>
import { mapState, mapActions } from 'vuex'
import FormPetugas from './FormPetugas'

export default {
  name: 'ViewPetugas',
  components: {
    FormPetugas
  },
  data () {
    return {
      formInsert: false,
      formUpdate: false,
      dataUpdateForm: null
    }
  },
  computed: {
    ...mapState('petugas', {
      petugas: state => state.data
    })
  },
  mounted () {
    this.refresh()
  },
  methods: {
    ...mapActions('logger', [
      'logErrors'
    ]),
    ...mapActions('logger/snackbar', [
      'success',
      'error'
    ]),
    ...mapActions('petugas', [
      'getData',
      'postData',
      'updateData',
      'destroyData'
    ]),
    refresh () {
      setTimeout(() => {
        this.getData()
          .then(() => {
            this.success('Success Loading Petugas Data')
          })
          .catch((error) => {
            this.error('Error Loading Petugas Data')
            this.logErrors(error)
          })
      }, 2000)
    },
    showUpdateForm (data) {
      this.formUpdate = true
      this.dataUpdateForm = data
    },
    cancelInsertForm () {
      this.formInsert = false
    },
    cancelUpdateForm () {
      this.formUpdate = false
    },
    submitUpdateForm (data) {
      this.updateData(data)
        .then(() => {
          this.success('Success Update ' + data.nama + ' to database.')
          this.refresh()
        })
        .catch((error) => {
          this.error('Oops Something Wrong when updating data.')
          this.logErrors(error)
        })
      this.formUpdate = false
    },
    submitDestroyForm (data) {
      this.destroyData(data)
        .then(() => {
          this.success('Success Delete ' + data.nama + ' to database.')
          this.refresh()
        })
        .catch((error) => {
          this.error('Oops Something Wrong when deleting data.')
          this.logErrors(error)
        })
      this.formUpdate = false
    },
    submitInsertForm (data) {
      this.postData(data)
        .then(() => {
          this.success('Success Insert ' + data.nama + ' to database.')
          this.refresh()
        })
        .catch((error) => {
          this.error('Oops Something Wrong when inserting data.')
          this.logErrors(error)
        })
      this.formInsert = false
    }
  }
}
</script>

<style>

</style>
